/*!
 <PRE>
 SOURCE FILE : AbsStack.h
 DESCRIPTION.: Stack abstract class interface - no implementation.
 AUTHOR......: Selan R. dos Santos
 LOCATION....: DIMAp/UFRN.
 STARTED ON.: August/2005
 CHANGES.....: None.

 TO COMPILE..: Not to be compiled.

 LAST UPDATE.: August 25th, 2005.
 </pre>
*/

#ifndef ABSSTACK_H_
#define ABSSTACK_H_


template <class Object>
class AbsStack
{
  public:
  AbsStack( ) { }            // Default constructor
  virtual ~AbsStack( ) { }   // Default destructor

  // Basic members
  virtual void push( const Object & x ) = 0;
  virtual const Object & pop( ) = 0;
  virtual const Object & top( ) const = 0;

  virtual bool isEmpty( ) const = 0;
  virtual void makeEmpty( ) = 0;

  private:
  // Disable copy constructor
  AbsStack( const AbsStack & ){ /* empty */}
};


#endif

/* --------------------- [ End of the AbsStack.h header ] ------------------- */
/* ========================================================================= */
